import bottle
import os
import xmltodict

from configparser import ConfigParser
from services.basicservice import BasicService
from servicestub import ServiceStub
from singleton import Singleton


class Jnfd(BasicService, metaclass=Singleton):
    servicePath: str

    def __init__(self):
        super().__init__(os.path.dirname(os.path.abspath(__file__)))

    def registerRoutes(self, servicestub: ServiceStub):
        self.log.info('Регистрация сервиса')

        conf = ConfigParser()
        conf.read(os.path.join(os.path.dirname(os.path.abspath(__file__)), 'config.ini'))
        self.servicePath = conf.get('jnfd', 'path') if conf.has_option('jnfd', 'path') else '/NFDService'
        self._loadCases('cases.json')

        servicestub.route(self.servicePath, method='POST', callback=self.req)

    def req(self):
        body = xmltodict.parse(bottle.request.body.read())
        self.log.info("Данные запроса '%s'" % str(body))
        method = list(body["soapenv:Envelope"]["soapenv:Body"].keys())[0]
        print(method)
        return self._createResponse(method)


instance = Jnfd()
